// Market application. Copyright  1996-2000 Swarm Development Group.
// This library is distributed without any warranty; without even the
// implied warranty of merchantability or fitness for a particular purpose.
// See file LICENSE for details and terms of copying.

/*
 * W. Brian Arthur.  Simulates the Bray problem, with inductive learning.
 * Version 95.2.7a  This version assumes that fundamental trading starts
 * off heavily believed by the agents.
 *
 * (Swarm) code taken and retooled to run under Swarm. Quick port, lots
 * of global variables left in.
 */
#import <simtools.h>
#import <simtoolsgui.h>
#import "MarketObserverSwarm.h"

int
main (int argc, const char **argv)
{
  MarketObserverSwarm *observerSwarm;
  
  initSwarm (argc, argv);

  observerSwarm = [MarketObserverSwarm createBegin: globalZone];
  SET_WINDOW_GEOMETRY_RECORD_NAME (observerSwarm);
  observerSwarm = [observerSwarm createEnd];

  [observerSwarm buildObjects];
  [observerSwarm buildActions];
  [observerSwarm activateIn: nil];
  [observerSwarm go];

  return 0;
}
